//----------------------------------------------------------------------------------
//		SIMDʌ݊p`t@C
//
//		$Log: simdemul.h,v $
//		Revision 1.5  2009-03-06 12:12:38+09  Blacksword
//		Added _mm_lddqu_ps.
//
//		Revision 1.4  2009-02-18 05:53:51+09  Blacksword
//		Added _mm_stream_load_si128 emulation.
//
//		Revision 1.3  2009-02-18 05:12:32+09  Blacksword
//		Added Comments.
//
//		last mod $Id: simdemul.h,v 1.5 2009-03-06 12:12:38+09 Blacksword Exp $
//
//----------------------------------------------------------------------------------
#if !defined(__SIMDEMUL__)
#define __SIMDEMUL__

#if defined(SSE41)
#include <smmintrin.h>
#define SSSE3
#endif
#if defined(SSSE3)
#include <tmmintrin.h>
#define SSE3
#endif
#if defined(SSE3)
#include <pmmintrin.h>
#define SSE2
#endif
#if defined(SSE2)
#include <emmintrin.h>
#endif

#if defined(__INTEL_COMPILER)
//#include <ia32intrin.h>
#else
//#include <intrin.h>
#define _rdtsc __rdtsc
#endif

#if defined(SSE2)
#define _mm_load_esi32(src) (_mm_castps_si128(_mm_load_ss((float*)(src))));
#define _mm_store_esi32(dst, val) _mm_store_ss((float*)(dst), _mm_castsi128_ps(val))
#define _mm_movemask_epi32(r) (_mm_movemask_ps(_mm_castsi128_ps(r)));
#if !defined(SSE3)
#define _mm_lddqu_si128 _mm_loadu_si128
#define	_mm_lddqu_ps(x)	_mm_loadu_ps(x)
static inline __m128 _mm_hadd_ps(__m128 a, __m128 b)
{
	__m128 c = a;
	a = _mm_shuffle_ps(a, b, _MM_SHUFFLE(2,0,2,0));
	c = _mm_shuffle_ps(c, b, _MM_SHUFFLE(3,1,3,1));
	return _mm_add_ps(a, c);
}
#else	// for SSE3
#define	_mm_lddqu_ps(x)	_mm_castsi128_ps(_mm_lddqu_si128((__m128i*)(x)))
#endif	// for SSE3
#if !defined(SSSE3)
static inline __m128i _mm_abs_epi16(__m128i __m1)
{
	static const __m128i c0 = {0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0, 0,0};
	register __m128i __m2 = _mm_cmpgt_epi16(c0, __m1);
	__m1 = _mm_xor_si128(__m1, __m2);
	return	_mm_sub_epi16(__m1, __m2);
}
static inline __m128i _mm_hadd_epi32(__m128i a, __m128i b)
{
	__m128i c = a;
	a = _mm_castps_si128(_mm_shuffle_ps(_mm_castsi128_ps(a), _mm_castsi128_ps(b), _MM_SHUFFLE(2,0,2,0)));
	c = _mm_castps_si128(_mm_shuffle_ps(_mm_castsi128_ps(c), _mm_castsi128_ps(b), _MM_SHUFFLE(3,1,3,1)));
	return _mm_add_epi32(a, c);
}
#endif	// for SSSE3
#if !defined(SSE41)
static inline __m128i _mm_mullo_epi32( __m128i a, __m128i b )
{
	__m128i t0;
	__m128i t1;
	
	t0 = _mm_mul_epu32(a,b);
	t1 = _mm_mul_epu32( _mm_shuffle_epi32( a, 0xB1 ),
	_mm_shuffle_epi32( b, 0xB1 ) );
	
	t0 = _mm_shuffle_epi32( t0, 0xD8 );
	t1 = _mm_shuffle_epi32( t1, 0xD8 );
	
	return _mm_unpacklo_epi32( t0, t1 );
}
#define _mm_stream_load_si128(x) _mm_load_si128(x)
#define _mm_stream_load_ps(x) _mm_load_ps(x)
#else	// SSE41 defiined
#define _mm_stream_load_ps(x) _mm_castsi128_ps(_mm_stream_load_si128((__m128i*)(x)))
#endif	// for SSE41
#endif	// for SSE2
#endif	// for __SIMDEMUL__
